<template>
  <div class="app-container">
    <el-form
      :model="queryParams"
      ref="queryForm"
      :inline="true"
      v-show="showSearch"
      label-width="68px"
    >
      <el-form-item label="年份" prop="year">
        <el-select
          v-model="queryParams.year"
          placeholder="请选择年份"
          clearable
        >
          <el-option
            v-for="year in yearList"
            :key="year"
            :label="year"
            :value="year"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="月份" prop="month">
        <el-select
          v-model="queryParams.month"
          placeholder="请选择月份"
          clearable
        >
          <el-option label="01" value="01"></el-option>
          <el-option label="02" value="02"></el-option>
          <el-option label="03" value="03"></el-option>
          <el-option label="04" value="04"></el-option>
          <el-option label="05" value="05"></el-option>
          <el-option label="06" value="06"></el-option>
          <el-option label="07" value="07"></el-option>
          <el-option label="08" value="08"></el-option>
          <el-option label="09" value="09"></el-option>
          <el-option label="10" value="10"></el-option>
          <el-option label="11" value="11"></el-option>
          <el-option label="12" value="12"></el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="州市" prop="cityCode">
        <el-select
          v-model="queryParams.cityCode"
          placeholder="请选择州市"
          clearable
        >
          <el-option
            v-for="region in regionOptions"
            :key="region.cityShortName"
            :label="region.cityShortName"
            :value="region.code"
          />
        </el-select>
      </el-form-item>

      <el-form-item label="申请人类型" label-width="100px">
        <template>
          <el-checkbox-group v-model="checkedApplicantTypes">
            <el-checkbox
              v-for="t in applicantTypeList"
              :label="t.id"
              :key="t.id"
              >{{ t.name }}</el-checkbox
            >
          </el-checkbox-group>
        </template>
      </el-form-item>
      <el-form-item label="专利类型" label-width="100px">
        <el-checkbox-group v-model="checkedPatentTypes">
          <el-checkbox v-for="t in patentTypeList" :label="t.id" :key="t.id">{{
            t.name
          }}</el-checkbox>
        </el-checkbox-group>
      </el-form-item>

      <el-form-item style="margin-left: 20px;">
        <el-button
          type="primary"
          icon="el-icon-search"
          size="mini"
          @click="handleQuery"
          >搜索</el-button
        >
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery"
          >重置</el-button
        >
        <el-button type="primary"  size="mini" @click="handleExport"
          >导出列表</el-button
        >
      </el-form-item>
    </el-form>

    <div id="scrollTable">
      <el-table
        v-loading="loading"
        :data="rzlApplicantRankingInfoList"
        :max-height="maxHeight"
        :header-cell-style="{ background: '#2a8eed', color: '#fafcfe' }"
      >
        <el-table-column :label="hearderTitle" align="center">
          <el-table-column label="排名" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row.ranking }}</span>
            </template>
          </el-table-column>
          <el-table-column label="专利权人名称" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row.patenteeName }}</span>
            </template>
          </el-table-column>
          <el-table-column label="有效专利量总计" align="center" v-if="this.showPatentTypeObj.totalCnt">
            <template slot-scope="scope">
              <span>{{ scope.row.patentsTotalNumber }}</span>
            </template>
          </el-table-column>
          <el-table-column label="申请人类型" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row.applicantType }}</span>
            </template>
          </el-table-column>
          <el-table-column
            label="发明"
            align="center"
            v-if="this.showPatentTypeObj.invention"
          >
            <template slot-scope="scope">
              <span>{{ scope.row.invent }}</span>
            </template>
          </el-table-column>
          <el-table-column
            label="实用新型"
            align="center"
            v-if="this.showPatentTypeObj.modelUtility"
          >
            <template slot-scope="scope">
              <span>{{ scope.row.utilityModel }}</span>
            </template>
          </el-table-column>
          <el-table-column
            label="外观设计"
            align="center"
            v-if="this.showPatentTypeObj.appearance"
          >
            <template slot-scope="scope">
              <span>{{ scope.row.appearanceDesign }}</span>
            </template>
          </el-table-column>
        </el-table-column>
      </el-table>
    </div>
  </div>
</template>

<script>
import {
  listRzlApplicantRankingInfo,
  getRzlApplicantRankingInfo,
  delRzlApplicantRankingInfo,
  addRzlApplicantRankingInfo,
  updateRzlApplicantRankingInfo,
  getHeaderList,
  getYearList,
  getRegionList,
} from "@/api/report/rzlApplicantRankingInfo";
import {
  getPatentTypes,
  getPatentType,
  getApplicantTypes,
  getAllPatentTypeIdStr,
  getAllApplicantTypeIdStr,
} from "@/api/staticdata";

export default {
  name: "RzlApplicantRankingInfo",
  data() {
    return {
      maxHeight: 0,

      checkedPatentTypes: [],
      patentTypeList: [],
      showPatentTypeObj: {
        invention: true,
        modelUtility: true,
        appearance: true,
        totalCnt:true
      },
      showApplicantTypeObj: {
        UC: true,
        SRI: true,
        IME: true,
        OT: true,
        PE: true,
      },
      checkedApplicantTypes: [],
      applicantTypeList: [],
      regionOptions: [],
      headerList: [],
      // 查询年份数据
      yearList: [],
      hearderTitle: "",
      hearderTitle2: "专利类型-全部",

      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 专利有效-申请人排名表格数据
      rzlApplicantRankingInfoList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 100,
        patenteeName: null,
        cityCode: null,
        cityCode: null,
        year: "2022",
        month: "12",
        applicantType: null,
        invent: null,
        utilityModel: null,
        appearanceDesign: null,
        patentType: null,
        patentsTotalNumber: null,
        status: null,
        patentTypes: null,
        applicantTypes: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {},
    };
  },
  created() {
    this.patentTypeList = getPatentTypes();
    this.applicantTypeList = getApplicantTypes();

    this.checkedPatentTypes = [];
    this.checkedApplicantTypes = [];

    for (let i = 0; i < this.patentTypeList.length; i++) {
      this.checkedPatentTypes.push(this.patentTypeList[i].id);
    }
    for (let i = 0; i < this.applicantTypeList.length; i++) {
      this.checkedApplicantTypes.push(this.applicantTypeList[i].id);
    }

    this.getRegion();
    this.getHeader(getAllPatentTypeIdStr(), getAllApplicantTypeIdStr());
    this.getYear();
    this.getList();

    this.$nextTick(() => {
      this.maxHeight = window.innerHeight - 200; //300是页面中除了表格外其他组件的高度
    });
  },
  methods: {
    /** 获取省市列表 */
    getRegion() {
      let params = {};
      getRegionList(params).then((response) => {
        this.regionOptions = response.data;
      });
    },
    getCheckedPatentTypeIdStr() {
      let ids = "";
      for (let i = 0; i < this.checkedPatentTypes.length; i++) {
        if (i > 0) {
          ids = ids + ",";
        }
        ids = ids + this.checkedPatentTypes[i];
      }
      return ids;
    },
    getCheckedApplicantTypeIdStr() {
      let ids = "";
      for (let i = 0; i < this.checkedApplicantTypes.length; i++) {
        if (i > 0) {
          ids = ids + ",";
        }
        ids = ids + this.checkedApplicantTypes[i];
      }
      return ids;
    },

    handerMethod({ row, column, rowIndex, columnIndex }) {
      // if (rowIndex === 0) {
      //     if (column.label == '地区' || column.label == '专利类型') {
      //         this.$nextTick(() => {
      //             var _c = document.getElementsByClassName(column.id);
      //             document.getElementsByClassName(column.id)[0].setAttribute('rowSpan', 2);
      //         });
      //         return column;
      //     }
      // } else if (rowIndex === 1) {
      //     if (column.label == '地区' || column.label == '专利类型') {
      //         return { display: 'none' };
      //     }
      // }
      // if (column[0].level == 1) {
      //     column[0].rowSpan = 2
      //     column[1].rowSpan = 0
      //     if (rowIndex === 1) {
      //         return { display: 'none' }
      //     }
      // }
    },

    allApplicantTypeSelect() {
      this.applicantTypeList = getApplicantTypes();
      this.checkedApplicantTypes = [];
      for (let i = 0; i < this.applicantTypeList.length; i++) {
        this.checkedApplicantTypes.push(this.applicantTypeList[i].id);
      }
    },

    allPatentTypeSelect() {
      // this.patentTypeList=getPatentTypes();
      this.checkedPatentTypes = [];
      for (let i = 0; i < this.patentTypeList.length; i++) {
        this.checkedPatentTypes.push(this.patentTypeList[i].id);
      }
    },
    showApplicantTypeTitle() {
      //如果一个都被选就自动全选
      if (this.checkedApplicantTypes.length == 0) {
        this.allApplicantTypeSelect();
      }
      let allTypes = getApplicantTypes();
      for (let i = 0; i < allTypes.length; i++) {
        let id = allTypes[i].id;
        if (this.checkedApplicantTypes.indexOf(id) >= 0) {
          this.showApplicantTypeObj[allTypes[i].code] = true;
        } else {
          this.showApplicantTypeObj[allTypes[i].code] = false;
        }
      }


    },

    showPatentTypeTitle() {
      // hearderTitle2
      let title = "专利类型-";

      if (this.checkedPatentTypes.length == 0) {
        this.allPatentTypeSelect();
      }

      let allTypes = this.patentTypeList;
      for (let i = 0; i < allTypes.length; i++) {
        let id = allTypes[i].id;
        if (this.checkedPatentTypes.indexOf(id) >= 0) {
          this.showPatentTypeObj[allTypes[i].code] = true;
        } else {
          this.showPatentTypeObj[allTypes[i].code] = false;
        }
      }

      for (let i = 0; i < this.checkedPatentTypes.length; i++) {
        if (i > 0) {
          title = title + ",";
        }
        title = title + getPatentType(this.checkedPatentTypes[i]);
      }
      this.hearderTitle2 = title;

      if(this.checkedPatentTypes.length ==1){
        this.showPatentTypeObj.totalCnt = false;
      }else{
        this.showPatentTypeObj.totalCnt = true;
      }

      return;
    },

    /** 获取动态表头 */
    getHeader(patentTypes, applicantTypes) {
      this.queryParams.patentTypes = patentTypes;
      this.queryParams.applicantTypes = applicantTypes;
      let head = "统计时期";
      if (this.queryParams.year) {
        head = head + "-" + this.queryParams.year;
      }
      if (this.queryParams.month) {
        head = head + "-" + this.queryParams.month;
      }
      this.hearderTitle = head;

      this.showApplicantTypeTitle();
      this.showPatentTypeTitle();

      this.queryParams.startDate = this.queryParams.year;
      getHeaderList(patentTypes, applicantTypes).then((response) => {
        this.headerList = response.data;
      });
    },
    /** 获取查询年份列表 */
    getYear() {
      getYearList().then((response) => {
        this.yearList = response.data;
      });
    },

    /** 查询专利有效-申请人排名列表 */
    getList() {
      this.loading = true;
      listRzlApplicantRankingInfo(this.queryParams).then((response) => {
        this.rzlApplicantRankingInfoList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        patenteeName: null,
        cityCode: null,
        cityCode: null,
        year: null,
        month: null,
        applicantType: null,
        invent: null,
        utilityModel: null,
        appearanceDesign: null,
        patentType: null,
        patentsTotalNumber: null,
        remark: null,
        delFlag: null,
        status: 0,
        createTime: null,
        createBy: null,
        updateTime: null,
        updateBy: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      if (this.queryParams.month) {
        if (this.queryParams.year) {
          this.getHeader(
            this.getCheckedPatentTypeIdStr(),
            this.getCheckedApplicantTypeIdStr()
          );
          this.queryParams.pageNum = 1;
          this.getList();
        } else {
          this.$message("请选择年份");
        }
      } else {
        this.getHeader(
          this.getCheckedPatentTypeIdStr(),
          this.getCheckedApplicantTypeIdStr()
        );
        this.queryParams.pageNum = 1;
        this.getList();
      }
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加专利有效-申请人排名";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids;
      getRzlApplicantRankingInfo(id).then((response) => {
        this.form = response.data;
        this.open = true;
        this.title = "修改专利有效-申请人排名";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          if (this.form.id != null) {
            updateRzlApplicantRankingInfo(this.form).then((response) => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addRzlApplicantRankingInfo(this.form).then((response) => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal
        .confirm('是否确认删除专利有效-申请人排名编号为"' + ids + '"的数据项？')
        .then(function () {
          return delRzlApplicantRankingInfo(ids);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download(
        "report/rzlApplicantRankingInfo/export",
        {
          ...this.queryParams,
        },
        `rzlApplicantRankingInfo_${new Date().getTime()}.xlsx`
      );
    },
  },
};
</script>
